// Funciona

 import nslj.src.system.*; 
 import nslj.src.cmd.*; 
 import nslj.src.lang.*; 
 import nslj.src.math.*; 
 import nslj.src.display.*; 

 public class BumpAvoid extends NslModule /*(int tectsize)*/ 
{
	public NslDinDouble0 depthY ; /*()*/
	public NslDinDouble0 depthX ; /*()*/
	public NslDoutDouble1 baf ; /*(tectsize)*/			
	public NslDinDouble1 gaps ; /*(tectsize)*/
	public NslDoutDouble1 gapsf ; /*(tectsize)*/
	//public NslDoutDouble0 ps();
	public NslDoutDouble0 ps ; /*()*/
	public NslDinDouble0 psta ; /*()*/
	private NslDouble0 field_a ; /*()*/
	private NslDouble0 field_center ; /*()*/
	private NslDouble0 tune_tm ; /*()*/	// TUNE GAPS field (avoid bumping).
	private NslDouble0 tune_tm_base ; /*()*/
	private NslDouble1 tune_tm_layer ; /*(tectsize)*/
	private NslDouble0 safe_distance ; /*()*/
	private NslDouble0 rsta ; /*()*/
	private NslDouble0 th ; /*()*/

	public  void initSys()
	{
		rsta.set(1.0);	// Tactile & Bumping Avoid
		ps.set(0);
	}

	public  void simRun()
	{
		// both should be larger than zero for no bump
		/*if ((
 nslj.src.math.NslLeq.eval(depthY.get(),safe_distance.get()))&&(
 nslj.src.math.NslLeq.eval(depthX.get(),safe_distance.get()))) 	//Bumping.   
			ps.set(0);
		else
			ps.set(-(1.0));		// Go down fast: -2.0*/
            
            if(psta.get() == 1)
                ps.set(0);
            else
                ps.set(-1);
            

		if (
 nslj.src.math.NslLes.eval(tune_tm.get(),1.5))		// saturate tune_tm.
			tune_tm.set(
 nslj.src.math.NslAdd.eval(tune_tm.get(),tune_tm_base.get()));

		tune_tm_layer.set(tune_tm);
		tune_tm_layer.set(
 __nsltmp102=nslj.src.math.NslElemMult.eval(__nsltmp102,tune_tm_layer.get(),NslStep.eval(
 __nsltmp101=nslj.src.math.NslSub.eval(__nsltmp101,0,gaps.get()))));	// Modulate only already active neurons.

		gaps.set(
 __nsltmp103=nslj.src.math.NslSub.eval(__nsltmp103,gaps.get(),tune_tm_layer.get())); // gaps fields gets tuned.
		gapsf.set(gaps);

		ps.set(
 nslj.src.math.NslAdd.eval(ps.get(),
 nslj.src.math.NslElemMult.eval(rsta.get(),psta.get())));
   		//ps = nslSigma(ps,-1.0,1.0,-1.0,1.0);	
   		ps.set(NslSigmoid.eval(ps,-(1.0),1.0,-(1.0),1.0)) /* rule 108 */;
                
                float eccentricity = 0.3f; //0.3 normal
		// every bump it increases tune_tm until it reaches a saturation point.
                //System.out.println("Field center 1: "+ field_center.toString());
		if (
 nslj.src.math.NslGtr.eval(ps.get(),th.get()))
		{
                  //      System.out.println("Generaci'on de Field Center");
			field_center.set(
 nslj.src.math.NslAdd.eval(field_center.get(),eccentricity));	// Tunes baf by increasing eccentricity.
			(baf).set(field_center.getint(),field_a); // Generate Bumping Avoidance FIELD.
		}
		else
			baf.set(0);
                
                //System.out.println("Field center 2: "+ field_center.toString());
	}
	/* nslInitTempModule inserted by NPP */
public void nslInitTempModule() {
	/* Instantiation statements generated by NslPreProcessor */
	/* temporary variables */
	__nsltmp101 = new double[1];
	__nsltmp102 = new double[1];
	__nsltmp103 = new double[1];
	/* end of automatic instantiation statements */
	/* Intialisation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic intialisation statements */
}

	/* nslInitTempRun inserted by NPP */
public void nslInitTempRun() {
	/* Intialisation statements generated by NslPreProcessor */
	/* temporary variables */
	for (int i = 0; i < __nsltmp101.length; i++) {
		__nsltmp101[i] = 0;
}
	for (int i = 0; i < __nsltmp102.length; i++) {
		__nsltmp102[i] = 0;
}
	for (int i = 0; i < __nsltmp103.length; i++) {
		__nsltmp103[i] = 0;
}
	/* end of automatic intialisation statements */
}

	/* nslInitTempTrain inserted by NPP */
public void nslInitTempTrain() {
	/* Initialisation statements generated by NslPreProcessor */
	/* temporary variables */
	/* end of automatic intialisation statements */
}

	/* Declaration statements generated by NslPreProcessor */
	/* makeinst() declared variables */
	/* temporary variables */
	private  double[] __nsltmp101;
	private  double[] __nsltmp102;
	private  double[] __nsltmp103;
	/* constructor and related methods */
	/* nsl declarations */
	int tectsize;

	 /*GENERIC CONSTRUCTOR:   */
	 public BumpAvoid(String nslName, NslModule nslParent,int tectsize) {
		super(nslName, nslParent);
		this.tectsize = tectsize;
		
		makeInst(nslName, nslParent,tectsize); //by rodolfo 09/2002
                initSys(); //by rodolfo 09/2002
	}
	public void makeInst(String nslName, NslModule nslParent,int tectsize){ 
	 depthY=new NslDinDouble0 ("depthY",this); //NSLDECLS 
	 depthX=new NslDinDouble0 ("depthX",this); //NSLDECLS 
	 baf=new NslDoutDouble1 ("baf",this,tectsize); //NSLDECLS 
	 gaps=new NslDinDouble1 ("gaps",this,tectsize); //NSLDECLS 
	 gapsf=new NslDoutDouble1 ("gapsf",this,tectsize); //NSLDECLS 
	 ps=new NslDoutDouble0 ("ps",this); //NSLDECLS 
	 psta=new NslDinDouble0 ("psta",this); //NSLDECLS 
	 field_a=new NslDouble0 ("field_a",this); //NSLDECLS 
	 field_center=new NslDouble0 ("field_center",this); //NSLDECLS 
	 tune_tm=new NslDouble0 ("tune_tm",this); //NSLDECLS 
	 tune_tm_base=new NslDouble0 ("tune_tm_base",this); //NSLDECLS 
	 tune_tm_layer=new NslDouble1 ("tune_tm_layer",this,tectsize); //NSLDECLS 
	 safe_distance=new NslDouble0 ("safe_distance",this); //NSLDECLS 
	 rsta=new NslDouble0 ("rsta",this); //NSLDECLS 
	 th=new NslDouble0 ("th",this); //NSLDECLS 
	}
	/* end of automatic declaration statements */
}
